#ifndef __KERNELCALLBACK_LIB_H__
#define __KERNELCALLBACK_LIB_H__

#ifdef __cplusplus
extern "C" {
#endif


#define KCB_VER_MAJ		1
#define KCB_VER_MIN		1
#define KCB_VER_BUILD		0


#define KCID_CALLBACK		0
#define KCID_GETKERNELFN	2

enum {
	idGetModuleHandle,
	idGetProcAddress,
	idAllocPhysMem,
	idCacheRangeFlush,
	idCacheSync, 
	idCeGetCacheInfo,
	idCeSetMemoryAttributes,
	idCeSetPowerOnEvent,
	idCeVirtualSharedAlloc,
	idCreateStaticMapping,
	idDrWatsonClear,
	idDrWatsonFlush,
	idDrWatsonGetSize,
	idDrWatsonReadData,
	idDrWatsonWriteData,
	idForcePageout,
	idFreeIntChainHandler,
	idFreePhysMem,
	idGetCallerProcess,
	idGetStdioPathW,
	idGetSystemMemoryDivision, //This function is obsolete. ????
	idInterruptDisable,
	idInterruptDone,
	idInterruptInitialize,
	idInterruptMask,
	idKernelLibIoControl, // is this really user mode callable??
	idLoadDriver,
	idLoadIntChainHandler,
	idLockPages,
	idOpenWatchDogTimer,
	idPageOutModule, 
	idProfileCaptureStatus,
	idRefreshWatchDogTimer,
	idSetDbgZone,
	idSetInterruptEvent,
	idSetJITDebuggerPath,
	idSetStdioPathW, 
	idSetSystemMemoryDivision,
	idUnlockPages,
	idVirtualCopy,
	idVirtualCopyEx,
	idVirtualSetAttributes,
	idCloseHandle
};

extern void* KFn[];

BOOL GetKernelFn();
DWORD DoKernelCallBack(void* pArgs, DWORD size);

/*
Description:      Returns the library Version
Parameter:
Out-Parameter:
- pVerMaj:          Returns the major version number. Set this parameter to NULL if not required.
- pVerMin:          Returns the minor version number. Set this parameter to NULL if not required.
- pBuild:           Returns the build number.         Set this parameter to NULL if not required.
Return Value:		No return value.
*/
void KCBGetLibVersion(DWORD *pVerMaj, DWORD *pVerMin, DWORD *pBuild);



#ifdef __cplusplus
}
#endif


#endif
